##########################################
## name: Cisco_Calls.pl
## version: 0.9
## date: 11/22/07
## author: Kevin J. Mattakat
## description: 
## Use SSH to Get active calls on each voice PRI
## 		
##########################################
#use Net::Telnet::Cisco;
use Net::SSH::W32Perl;
use strict;

$ENV{HOME} = "D:\\websites\\ssh";

my $user = "cisco";
my $pass = "cisco";

my $h = $ARGV[0];
my $cmd = $ARGV[1];
my $arg = $ARGV[2];
my $indx = $ARGV[3];

my %t = ();

my $ssh = Net::SSH::W32Perl->new($h, protocol=>1, cipher=>'DES', port=>22);
$ssh->login($user, $pass);


if ($cmd eq 'index' || $cmd eq 'query'){
	my ($ints, $er, $ex) = $ssh->cmd('sh int | incl Serial.*:23');
	my @a = split ("\r\n",$ints);
	 foreach my $ser (@a){
	 	 if ($ser =~ m/^(Serial(\d+[\/\d+]*:23)).*/g){
		 	 my $ifname = $1;
			 print "$2";
	 		 if ($cmd eq 'query'){
		 		 if ($arg eq 'index'){
		 		 	print "?$2";
	 			 }
	 			 if ($arg eq 'name'){
		 			 print "?$1";
	 			 }
	 			 if ($arg eq 'description'){
		 			 print "?";
		 			 my $c = $2;
		 			 $c =~ s/:23//;
		 			 my $cc = "sh control t1 $c brie | incl Description";
		 			 my ($o, $er, $ex) = $ssh->cmd($cc);
		 			 $o =~ s/\s*\w+:\s*(.*)\r\n/$1/;
		 			 if ($o eq ""){
			 			 print "** Controller T1 $c for $ifname, Local PRI **";
		 			 }else{
			 			 print "$o";
		 			 }
	 			 }
 			 }
	 		 print "\n";
	 	 }
	}
}

if ($cmd eq 'get' && $arg eq 'activeCount'){
	my $c = "sh voice call $indx | incl S_CONNECT";
	my ($out, $er, $ex) = $ssh->cmd($c);
	#print $c;
	my @z = split("\r\n", $out);
	#print join("\n", @z);
	print scalar @z;
}